# DSPOptimizations Mod
This mod adds optimizations to DSP. Few optimizations are available currently, but more will be added in the future.

## Important Notice for Old Saves
The low resolution shells optimization is now obsolete with DSP v0.9. If you had lower resolution shells in your save made with this mod in an old version of the game, then the vanilla game will update them incorrectly. As of v1.0.6, this mod should update such modded shells correctly.

## Features
- Dense spheres with shells now impact the game's framerate much less
	- e.g. the framerate with a single sphere layer with 5240 shells with the game paused went from 8 fps to 24 fps
- Multithreading is added for the logic controlling belts going in and out of stations
	- this should greatly reduce the CPU time under the "Storage" category in the performance window
- Ejected sails will impact UPS much less (~15%) when not visible. You can choose to always hide them in the config
- Most of the lag from dyson node game logic has been eliminated
- Hidden sphere layers under construction cause less lag
- Shadows can be disabled in the config

## Commands
The following commands may be used with the [developer console](https://dsp-wiki.com/Developer_Console):
- `-resetLocalFactory`
	- completely resets the factory data for the nearby planet. This can eliminate lag that would have persisted even after deleting all buildings
	- requires a planet to be loaded
	- does not reset terrain, vegetation, or veins
- `-resetLocalSwarm`
	- completely resets all swarms for the nearby star, deleting all sails. This can eliminate permanent save bloat
	- requires the player to be near a star (within ~2 lyrs - the star name should be visible in the bottom left)
- `-resetLocalSphereLayer layerId`
	- instantly deletes a sphere layer without releasing sails
	- requires the player to be near a star (within ~2 lyrs - the star name should be visible in the bottom left)
	- `layerId` should be an integer between 1 and 10 corresponding to the ID of the sphere layer you wish to delete
- `-resetAllSpheresAndSwarms`
	- instantly deletes all dyson spheres and swarms for all stars. No sails will be released
	- if you have the dyson editor open while running this command, reopen it to see the changes

## Installation Note
This mod depends on [DSPModSave](https://dsp.thunderstore.io/package/CommonAPI/DSPModSave/). Make sure that you have the version under the CommonAPI name, rather than the old version released by crecheng. The old version has bugs, and may cause problems. The old version of the mod is marked as deprecated.

## Compatibility
Compatibility with the [Nebula Mod](https://dsp.thunderstore.io/package/nebula/NebulaMultiplayerMod/) is not tested, however there are plans to add and test compatibility in the future if needed.

## Bug Reports
If you encounter any bugs or issues, then please contact me either on discord at Selsion#0769, or by raising an issue on the [mod github page](https://github.com/Selsion/DSPMods/tree/main/DSPOptimizations).

## Changelog
- v1.1.11
	- further optimized dyson node logic, where buffer updates won't be run for invisible swarms
	- updated factory reset command to work with latest DSP update
- v1.1.10
	- updated station multithreading for compatibility with v0.9.26 of DSP
- v1.1.9
	- fixed vanilla bug where splitters and pilers may have their performance stats counted twice for the last factory
	- fixed bug where dyson shell colours aren't updated immediately
- v1.1.8
	- further optimization ejected sails down to ~15% of normal cpu time
	- fixed bug with swarm gpu stats
	- optimized dyson nodes to not update their colour on tick. should further improve ups for dense spheres
- v1.1.7
	- added optimization for ejected sails along with the option to hide them

Older version changes may be found [here](https://github.com/Selsion/DSPMods/blob/main/DSPOptimizations/changelog.txt).

## Attributions
Icon(s) made by [Freepik](https://www.freepik.com) from www.flaticon.com